#!/usr/bin/env python

import sys, socket, struct, time

NTP_VERSION = 3
NTP_MODE_CLIENT = 3
NTP_TS_REFERENCE_OFS = 16       # reference timestamp
UNIX_EPOCH = 2208988800

if len(sys.argv) == 1 :
	sys.exit("Usage: ntp_test.py <host>")

host = sys.argv[1]
s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
s.settimeout(5)

payload = chr((NTP_VERSION << 3) | NTP_MODE_CLIENT) + 47 * chr(0)
s.connect((host, 123))
while True :
	s.send(payload)
	resp = s.recv(4096)
	if resp :
		#print "rx", len(resp), repr(resp.replace('\0', '.'))
		t = struct.unpack(">I4", resp[NTP_TS_REFERENCE_OFS : NTP_TS_REFERENCE_OFS + 4])[0]
		print hex(ord(resp[0])), t - UNIX_EPOCH
	time.sleep(1)
